﻿Enumeration
  #s1
  #d1
  #b1
  #b2
  #b3
  #b4
  #b5
  #b6
  #bc
EndEnumeration

Global u$ ;uppercase
u$=PeekS(?lu)
;Debug u$
Global l$ ;lowerrcase
l$=PeekS(?ll)
;Debug l$
Global a$=u$+l$

Procedure.l isupper(s.s)
  ProcedureReturn FindString(u$,s,#PB_String_CaseSensitive)
EndProcedure

Procedure.l islower(s.s)
  ProcedureReturn FindString(l$,s,#PB_String_CaseSensitive)
EndProcedure

Procedure.l isletter(s.s)
  ProcedureReturn FindString(a$,s,#PB_String_CaseSensitive)
EndProcedure

Procedure.s toupper(s.s)
  m$=s
  p.l=isupper(m$)
  If p
    m$=Mid(u$,p,1)
  Else
    p.l=islower(m$)
    If p
      m$=Mid(u$,p,1)
    EndIf
  EndIf
  ProcedureReturn m$
EndProcedure

Procedure.s tolower(s.s)
  m$=s
  p.l=islower(m$)
  If p
    m$=Mid(l$,p,1)
  Else
    p.l=isupper(m$)
    If p
      m$=Mid(l$,p,1)
    EndIf
  EndIf
  ProcedureReturn m$
EndProcedure

;m$="nOrMaL sTrInGgAdGeT...";"Normal StringGadget..."
If OpenWindow(0, 0, 0, 640, 480, "case converter 1.0b", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  StringGadget(#s1, 0, 30, 320, 400, "",#PB_String_BorderLess|#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
  StringGadget(#d1, 320, 30, 320, 400, "",#PB_String_BorderLess|#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
  
  ButtonGadget(#b1,0,0,100,20,"lower",#BS_FLAT)
  ButtonGadget(#b2,100,0,100,20,"UPPER")
  ButtonGadget(#b3,200,0,100,20,"Title Case")
  ButtonGadget(#b4,300,0,100,20,"tOGGLE")
  ButtonGadget(#b5,400,0,100,20,"aLtErNaTe")
  ButtonGadget(#b6,500,0,100,20,"Like.Sentence")
  ButtonGadget(#bc,600,0,20,20,"<<")
  GadgetToolTip(#bc,"copy text to left panel")
  ;RandomSeed(12345)
  ;  SetWindowLong_(GadgetID(#b1), #GWL_STYLE,  #BS_FLAT)
  Repeat
    ev=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf
    Select ev
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #d1
            If EventType()=#PB_EventType_Focus ;#PB_EventType_LeftClick
                                               ;SetActiveGadget(#d1)
                                               ;Debug "we"
              SendMessage_(GadgetID(#d1),#EM_SETSEL,0,-1)
            EndIf
            
          Case #b6 ; Like.Sentence
            s.s=GetGadgetText(#s1)
            d.s=""
            nu.l=1
            For i=1 To Len(s)
              m$=Mid(s,i,1)
              If isletter(m$)
                If nu
                  m$=toupper(m$)
                  nu=0
                Else
                  m$=tolower(m$)
                EndIf
              EndIf;If isletter(m$)
              If m$="."
                nu=1
              EndIf
              d=d+m$
            Next i
            SetGadgetText(#d1,d)
            
          Case #b5 ; aLtErNaTe
            s.s=GetGadgetText(#s1)
            d.s=""
            nu.l=0
            For i=1 To Len(s)
              m$=Mid(s,i,1)
              If isletter(m$)
                If nu
                  m$=toupper(m$)
                  nu=1-nu
                Else
                  m$=tolower(m$)
                  nu=1-nu
                EndIf
              EndIf
              d=d+m$
            Next i
            SetGadgetText(#d1,d)
            
          Case #b4 ; tOGGLE
            s.s=GetGadgetText(#s1)
            d.s=""
            For i=1 To Len(s)
              m$=Mid(s,i,1)
              If isupper(m$)
                m$=tolower(m$)
              ElseIf islower(m$)
                m$=toupper(m$)
              EndIf
              d=d+m$
            Next i
            SetGadgetText(#d1,d)
            
          Case #bc ;<<
            SetGadgetText(#s1,GetGadgetText(#d1))
          Case #b3 ;Title Case
            s.s=GetGadgetText(#s1)
            d.s=""
            nu.l=1;need upper
            For i=1 To Len(s)
              m$=Mid(s,i,1)
              If isletter(m$)
                If nu
                  m$=toupper(m$)
                  nu=0
                Else
                  m$=tolower(m$)
                EndIf
              Else
                nu=1
              EndIf
              d=d+m$
            Next i
            SetGadgetText(#d1,d)
          Case #b2 ;upper
            s.s=GetGadgetText(#s1)
            d.s=""
            For i=1 To Len(s)
              m$=Mid(s,i,1)
              p.l=islower(m$)
              If p
                m$=Mid(u$,p,1)
              EndIf
              d=d+m$
            Next i
            SetGadgetText(#d1,d)
            
          Case #b1 ;lower
            s.s=GetGadgetText(#s1)
            d.s=""
            For i=1 To Len(s)
              m$=Mid(s,i,1)
              p.l=isupper(m$)
              If p
                m$=Mid(l$,p,1)
              EndIf
              d=d+m$
            Next i
            SetGadgetText(#d1,d)
        EndSelect
        
    EndSelect
    
  Until ev = #PB_Event_CloseWindow
EndIf

DataSection
  lu:
  Data.u 65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90
  Data.u 1040,1041,1042,1043,1044,1045,1025,1046,1047,1048,1049,1050,1051,1052,1053,1054
  Data.u 1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,0
  ll:
  Data.u 97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122
  Data.u 1072,1073,1074,1075,1076,1077,1105,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090
  Data.u 1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,0
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 61
; FirstLine = 46
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = ulcase.ico
; Executable = case.exe